// WSAView.cpp : implementation of the CWSAView class
//

#include "stdafx.h"
#include "WSA.h"

#include "WSADoc.h"
#include "WSAView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWSAView

IMPLEMENT_DYNCREATE(CWSAView, CTreeView)

BEGIN_MESSAGE_MAP(CWSAView, CTreeView)
	//{{AFX_MSG_MAP(CWSAView)
	ON_NOTIFY_REFLECT(TVN_ENDLABELEDIT, OnEndlabeledit)
	ON_NOTIFY_REFLECT(TVN_BEGINDRAG, OnBegindrag)
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONUP()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CTreeView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CTreeView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CTreeView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWSAView construction/destruction

CWSAView::CWSAView()
{
	// TODO: add construction code here
	m_imageList.Create( IDB_TREE , 14, 1, RGB(255, 0, 0));


}

CWSAView::~CWSAView()
{
}

BOOL CWSAView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	cs.style |= TVS_HASLINES | TVS_LINESATROOT | TVS_HASBUTTONS | TVS_EDITLABELS ;
	return CTreeView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CWSAView drawing

void CWSAView::OnDraw(CDC* pDC)
{
	CWSADoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
}

void CWSAView::OnInitialUpdate()
{
	CTreeView::OnInitialUpdate();

	// TODO: You may populate your TreeView with items by directly accessing
	//  its tree control through a call to GetTreeCtrl().

	InvalidateRect(NULL);
	CTreeCtrl&	WSATree = GetTreeCtrl();
	WSATree.DeleteAllItems();


	WSATree.SetImageList( &m_imageList, TVSIL_NORMAL);


	CWSADoc*	pDoc = GetDocument();

	DWORD	dwData;

	HTREEITEM	hBank;
	HTREEITEM	hGroup;
	HTREEITEM	hSound;
	HTREEITEM	hKit;
	CString treeItem;
	
	int		i, j ;
	for (int loop = 0; loop<2; loop++)
	{
		treeItem.Format("User %i", loop+1);
		hBank = WSATree.InsertItem(treeItem, 1, 1);


		for ( i = 0; i < 16 ; i++)
		{
			
			hGroup = WSATree.InsertItem( pDoc->arBank[loop].m_Group[i].m_GroupName,1, 1, hBank );
			dwData = (DWORD)&(pDoc->arBank[loop].m_Group[i]);
			WSATree.SetItemData( hGroup , dwData );

			for ( j = 0; j < 8; j++)
			{
				hSound = WSATree.InsertItem( pDoc->arBank[loop].m_Group[i].m_Sound[j].m_SoundName ,0, 0, hGroup );
				dwData = (DWORD)&(pDoc->arBank[loop].m_Group[i].m_Sound[j]);
				WSATree.SetItemData( hSound , dwData );
			}

		}

		for (i = 0; i < 2; i++) 
		{
			hKit = WSATree.InsertItem( pDoc->arBank[loop].m_Kit[i].m_KitName,1, 1, hBank );
			dwData = (DWORD)&(pDoc->arBank[loop].m_Kit[i]);
			WSATree.SetItemData( hKit , dwData );
		}


	}



}

/////////////////////////////////////////////////////////////////////////////
// CWSAView printing

BOOL CWSAView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CWSAView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CWSAView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CWSAView diagnostics

#ifdef _DEBUG
void CWSAView::AssertValid() const
{
	CTreeView::AssertValid();
}

void CWSAView::Dump(CDumpContext& dc) const
{
	CTreeView::Dump(dc);
}

CWSADoc* CWSAView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CWSADoc)));
	return (CWSADoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CWSAView message handlers

void CWSAView::OnEndlabeledit(NMHDR* pNMHDR, LRESULT* pResult) 
{
	TV_DISPINFO* pTVDispInfo = (TV_DISPINFO*)pNMHDR;
	// TODO: Add your control notification handler code here

	CTreeCtrl&	WSATree = GetTreeCtrl();
	HTREEITEM	hTreeItem;
	CString		szItemText;

	CDocument* pDoc = GetDocument();

	hTreeItem = WSATree.GetSelectedItem();

	szItemText = pTVDispInfo->item.pszText;

	CObject *obj = (CObject*)WSATree.GetItemData(hTreeItem);

	CGroup	*group = dynamic_cast<CGroup*>(obj);
	if (group )
	{
		//
		group->m_GroupName = szItemText;
		WSATree.SetItemText(hTreeItem, szItemText);
		pDoc->SetModifiedFlag(TRUE);

	}
		else
		{
			CSound	*sound = dynamic_cast<CSound*>(obj);
			if (sound !=NULL)
			{
				//
				sound->m_SoundName = szItemText;
				WSATree.SetItemText(hTreeItem, szItemText);
				pDoc->SetModifiedFlag(TRUE);
			}
			else
			{
				CKit	*kit = dynamic_cast<CKit*>(obj);
				if (sound !=NULL)
				{
					//
					kit->m_KitName = szItemText;
					WSATree.SetItemText(hTreeItem, szItemText);
					pDoc->SetModifiedFlag(TRUE);
				}
			}
		}



	*pResult = 0;
}

void CWSAView::OnBegindrag(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	// TODO: Add your control notification handler code here

	m_dragItem = pNMTreeView -> itemNew.hItem;

	m_bIsDragging = TRUE;


	SetCapture();

	
	*pResult = 0;
}



void CWSAView::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	if (m_bIsDragging == TRUE ) {
		CTreeCtrl&	WSATree = GetTreeCtrl();
		CPoint	ptTree( point );
		ClientToScreen( &point);
		UINT uHitTest = TVHT_ONITEM;
		m_dragTarget = WSATree.HitTest(ptTree, &uHitTest);
	}

	CTreeView::OnMouseMove(nFlags, point);
}

void CWSAView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default

	if (m_bIsDragging == TRUE ) {
		m_bIsDragging = FALSE;
		ReleaseCapture();
	
		if (m_dragTarget != NULL) {
		
			AfxMessageBox(" Drag Completed ");
		}
	
	}
	
	CTreeView::OnLButtonUp(nFlags, point);
}
